import { Badge } from "antd";
import React from "react";

/** 广告状态 */
export const ADSTATUSEnum = {
    'STATUS_PENDING': '审核中',
    'STATUS_DENIED': <Badge status="error" text={<span style={{ fontSize: 12 }}>审核不通过</span>} />,
    'STATUS_SUSPEND': <Badge status="warning" text={<span style={{ fontSize: 12 }}>暂停中</span>} />,
    'STATUS_READY': <Badge status="default" text={<span style={{ fontSize: 12 }}>未到投放时间</span>} />,
    'STATUS_ACTIVE': <Badge status="processing" text={<span style={{ fontSize: 12 }}>投放中</span>} />,
    'STATUS_STOP': '投放结束',
    'STATUS_ACTIVE_CAMPAIGN_SUSPEND': '广告被暂停',
    'STATUS_PART_READY': '部分待投放',
    'STATUS_PART_ACTIVE': '部分投放中',
    'STATUS_DELETED': <Badge status="error" text={<span style={{ fontSize: 12 }}>已删除</span>} />,
    'STATUS_UNKNOWN': '未知状态',
    'STATUS_FROZEN': '冻结',
    'STATUS_PREPARE': '准备中'
}

/** 出价方式 */
export enum PRICINGEnum {
    "BID_MODE_CPC" = "CPC",
    "BID_MODE_CPA" = "CPA",
    "BID_MODE_CPM" = "CPM",
    "BID_MODE_OCPC" = "oCPC",
    "BID_MODE_OCPM" = "oCPM"
}

export enum LANDINGTYPEEnum {
    'PROMOTED_OBJECT_TYPE_APP_ANDROID' = 'Android 应用',
    'PROMOTED_OBJECT_TYPE_APP_IOS' = 'IOS 应用',
    'PROMOTED_OBJECT_TYPE_ECOMMERCE' = '电商推广',
    'PROMOTED_OBJECT_TYPE_LINK_WECHAT' = '品牌活动推广',
    'PROMOTED_OBJECT_TYPE_APP_ANDROID_MYAPP' = '应用宝推广',
    'PROMOTED_OBJECT_TYPE_LOCAL_ADS_WECHAT' = '本地广告',
    'PROMOTED_OBJECT_TYPE_QQ_BROWSER_MINI_PROGRAM' = 'QQ 浏览器小程序',
    'PROMOTED_OBJECT_TYPE_QQ_MESSAGE' = 'QQ 消息',
    'PROMOTED_OBJECT_TYPE_QZONE_VIDEO_PAGE' = '视频说说',
    'PROMOTED_OBJECT_TYPE_LEAD_AD' = '销售线索收集',
    'PROMOTED_OBJECT_TYPE_MINI_GAME_WECHAT' = '微信小游戏',
    'PROMOTED_OBJECT_TYPE_MINI_GAME_QQ' = 'QQ 小游戏',
    'PROMOTED_OBJECT_TYPE_WECHAT_OFFICIAL_ACCOUNT' = '微信公众号',
    'PROMOTED_OBJECT_TYPE_APP_QUICK_APP' = '快应用',
}